<template>
  <div
    data-component-group="threads-dropdown"
    data-component="actions"
  >
    <v-menu
      v-model="isOn"
      bottom
      offset-y
      :max-height="maxHeight"
      transition="slide-y-transition"
      nudge-bottom="10"
      content-class="thread-actions"
      :close-on-click="true"
      :close-on-content-click="false"
    >
      <v-btn
        slot="activator"
        class="trigger toggle-menu elevation-4"
        color="primary"
        small
        dark
        round
        :class="getTriggerClass()"
        @click="toggleMenu()"
      >
        {{ triggerLabel }}
        <v-icon>
          keyboard_arrow_down
        </v-icon>
      </v-btn>

      <Can
        I="view-users-to-assign"
        a="thread"
      >
        <v-text-field
          v-if="canSearch"
          ref="searchUser"
          v-model="search"
          prepend-inner-icon="account_circle"
          label="Search for users..."
          type="text"
          box
          :hide-details="true"
          :background-color="colors.shades.white"
          :autofocus="isOn"
          :loading="isLoading"
          @input="onSearch"
        />
      </Can>

      <v-list class="default-list">
        <v-list-tile
          v-for="(item, index) in items"
          :key="index"
          :value="item"
          @click="changeItem(item)"
        >
          <v-list-tile-title>
            {{ item.label }}
          </v-list-tile-title>
        </v-list-tile>
      </v-list>
    </v-menu>
  </div>
</template>

<script>
  import uid from 'uid';
  import colors from 'vuetify/es5/util/colors';
  import stringEscape from 'js-string-escape';
  import { isObj, debounce } from '../../../utils';

  // TODO: Translate component
  const debouncer = debounce({
    id: uid(),
    timeout: 500
  });

  export default {
    props: {
      thread: {
        type: Object,
        default: undefined
      },
      totalSelected: {
        type: Number,
        default: 0
      },
      triggerLabel: {
        type: String,
        required: true
      },
      actions: {
        type: Array,
        required: true
      },
      disabled: {
        type: Boolean,
        default: false
      },
      canSearch: {
        type: Boolean,
        default: true
      },
      onChangeItem: {
        type: Function,
        required: true
      }
    },
    data() {
      return {
        search: '',
        items: [],
        maxHeight: 500,
        isOn: false,
        isLoading: false,
        colors
      };
    },
    computed: {
      country() {
        return this.$store.getters['config/country'];
      },
      hasThread() {
        return isObj(this.thread);
      }
    },
    watch: {
      actions(nextActions) {
        this.setActions(nextActions);
      },
      isOn(nextIsOn) {
        if (this.canSearch && nextIsOn && this.$ability.can('view-users-to-assign', 'thread')) {
          this.focusInput();
        }
      }
    },
    created() {
      this.setActions(this.actions);
    },
    methods: {
      setActions(nextActions) {
        this.items = nextActions;

        if (!this.$ability.can('assign', 'thread')) {
          this.items = this.items.filter(({ action }) => action !== 'user' && action !== 'editor' && action !== 'account_manager');
        }

        if (!this.$ability.can('publish', 'thread')) {
          this.items = this.items.filter(({ action }) => action !== 'publish');
        }

        if (!this.$ability.can('assign-to-editors-queue', 'thread')) {
          this.items = this.items.filter(({ action }) => action !== 'editor');
        }

        if (!this.$ability.can('mass-comment', 'thread')) {
          this.items = this.items.filter(({ action }) => action !== 'comment');
        }

        const canDeny = this.$ability.can('mass-deny', 'thread') || (this.hasThread && this.thread.permissions.indexOf('deny-with-comment') > -1);

        if (!canDeny) {
          this.items = this.items.filter(({ action }) => action !== 'deny');
        }

        const canReopen = this.hasThread && this.thread.permissions.indexOf('reopen-with-comment') > -1;

        if (!canReopen) {
          this.items = this.items.filter(({ action }) => action !== 'reopen');
        }

        if (!this.$ability.can('mass-assign', 'thread')) {
          this.items = this.items.filter(({ action }) => action !== 'deselect');
        }

        if (!this.$ability.can('accept', 'thread') || !this.$ability.can('see-accept-link', 'thread')) {
          this.items = this.items.filter(({ action }) => action !== 'accept');
        }
      },
      focusInput() {
        const input = this.getInputNode();
        this.$nextTick(() => input.focus());
      },
      getInputNode() {
        return this.$refs.searchUser.$el.querySelector('input');
      },
      onSearch(search) {
        this.search = search;
        debouncer(() => this.debouncedSearch());
      },
      debouncedSearch() {
        if (this.search !== '') {
          this.getAssignableUsers();
        } else {
          this.items = this.actions;
        }
      },
      getAssignableUsers() {
        const { country, search } = this;
        const formattedSearch = stringEscape(search);
        const query = {
          target_country: country.code,
          search: formattedSearch
        };

        this.isLoading = true;
        return this.$store.dispatch('users/getAssignableUsers', query)
          .then((res) => {
            const { data } = res.data;
            this.items = data.map(({ id, firstname, lastname }) => ({
              action: 'user',
              label: `${firstname} ${lastname}`,
              id
            }));

            this.isLoading = false;
            return res;
          });
      },
      toggleMenu() {
        this.isOn = !this.isOn;
      },
      getTriggerClass() {
        return {
          active: this.isOn,
        };
      },
      changeItem(item) {
        this.toggleMenu();
        this.onChangeItem(item);
      }
    }
  };
</script>

<style lang="stylus">
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="threads-dropdown"] {
    &[data-component="actions"] {
      margin: 0 0 0 16px;

      .v-menu {
        width: 100%;
      }

      .v-input {
        padding: 0;
        margin: 0;
      }

      .trigger.toggle-menu {
        width: 100%;
        min-width: 60px;
        height: 34px;
        border-radius: 4px;
        letter-spacing: 0.16px;
        font-weight: 500;
        line-height: 24px;
        padding-right: 6px;
        padding-left: 8px;
        margin: 0;

        &:not(.active) {
          .v-icon {
            &:last-child {
              transform: rotate(0deg);
              transition: all 0.15s ease-in-out;
            }
          }
        }

        &.active {
          background-color: $colors.primary;

          .v-icon {
            &:last-child {
              transform: rotate(180deg);
              transition: all 0.15s ease-in-out;
            }
          }
        }
      }

      .v-btn {
        margin: 0;
        padding-left: 16px;
        padding-right: 16px;
        border-radius: 4px;

        .v-icon {
          margin: 0 0 0 10px;
        }
      }
    }
  }
</style>
